## belenios 1.4+dfsg

=== Makefile ===
minimal:
	ocamlbuild minimal.otarget

all:
	ocamlbuild all.otarget

check: all
	demo/demo.sh

clean:
	ocamlbuild -clean
	rm -f *~

tree: _build/tree.html

_build/tree.html: _build/_digests
	mkdir -p _build
	tree -o $@ -H '..'  -I '_build|_run|*~'

.PHONY: doc
doc:
	ocamlbuild doc.otarget
	$(MAKE) doc/specification.pdf

doc/specification.pdf: doc/specification.tex
	cd doc && for u in 1 2 3; do pdflatex specification.tex; done

archive:
	@if [ `git status --porcelain | grep -v '^?? ' | wc -l ` -eq 0 ]; then \
	  COMMIT_ID=`git describe --tags`; \
	  VERSION=`cat VERSION`; \
	  if [ "$$(printf $$COMMIT_ID | head -c$$(printf $$VERSION | wc -c))" = "$$VERSION" ]; then \
	    git archive --prefix=belenios-$$COMMIT_ID/ $$COMMIT_ID | gzip -9n > ../belenios-$$COMMIT_ID.tar.gz; \
	    ln -sf belenios-$$COMMIT_ID.tar.gz ../belenios.tar.gz; \
	    ls -l ../belenios.tar.gz; \
	  else \
	    echo "VERSION is not up-to-date!"; exit 1; \
	  fi; \
	else \
	  echo "The tree is not clean!"; exit 1; \
	fi

=== debian/changelog ===
belenios (1.4+dfsg-2) unstable; urgency=medium

  * Add ocamlbuild to Build-Depends

 -- Stéphane Glondu <glondu@debian.org>  Thu, 27 Jul 2017 06:56:00 +0200

belenios (1.4+dfsg-1) unstable; urgency=medium

  * Initial release (Closes: #859723)

 -- Stéphane Glondu <glondu@debian.org>  Thu, 06 Apr 2017 14:06:07 +0200

=== debian/control ===
Source: belenios
Priority: optional
Section: misc
Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
Uploaders: Stéphane Glondu <glondu@debian.org>
Build-Depends:
 debhelper (>= 10),
 dh-ocaml,
 ocaml-findlib,
 ocamlbuild,
 libzarith-ocaml-dev,
 libcalendar-ocaml-dev,
 libuuidm-ocaml-dev,
 libcryptokit-ocaml-dev,
 libatdgen-ocaml-dev,
 libyojson-ocaml-dev,
 libcmdliner-ocaml-dev,
 ocaml-nox,
 markdown,
 texlive-latex-extra,
 texlive-fonts-recommended,
 texlive-fonts-extra,
 lmodern,
 uuid-runtime
Standards-Version: 3.9.8
Homepage: https://www.belenios.org/
Vcs-Browser: https://anonscm.debian.org/git/pkg-ocaml-maint/packages/belenios.git
Vcs-Git: https://anonscm.debian.org/git/pkg-ocaml-maint/packages/belenios.git

Package: belenios-tool
Architecture: any
Depends:
 ${ocaml:Depends},
 ${shlibs:Depends},
 ${misc:Depends}
Description: verifiable voting system (command-line tool)
 Belenios aims at providing an easy to use voting system, guaranteeing
 state-of-the-art security, namely vote privacy and verifiability. It
 can be used in many types of elections, ranging from scientific
 councils to sport associations.
 .
 It consists of a command-line tool and a web server. Both use the
 same backend and can be used to organize elections and perform
 verifications.
 .
 Security properties of the system are:
  * Vote privacy: No one can learn the vote of a voter. Vote privacy
    relies on the encryption of the votes.
  * End-to-end verifiablity: Every voter can check that her vote has
    been counted and only eligible voters may vote. End-to-end
    verifiablity relies on the fact that the ballot box is public
    (voters can check that their ballots have been received) and on
    the fact that the tally is publicly verifiable (anyone can recount
    the votes). Moreover, ballots are signed by the voter credential
    (only eligible voters are able to vote).
 .
 This package provides the command-line tool, which is the most
 convenient way to exercise the verifiability capabilities of the
 system. It can be used to run an election without using the web
 server, and to monitor an election running on a web server.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

%:
	dh $@ --with ocaml

.PHONY: override_dh_auto_build
override_dh_auto_build:
	$(MAKE) minimal
	$(MAKE) doc
	_build/belenios-tool --help=groff > debian/belenios-tool.1

.PHONY: override_dh_auto_test
override_dh_auto_test:
	demo/demo.sh

=== debian/watch ===
version=3
opts="dversionmangle=s/\+dfsg//" \
https://gforge.inria.fr/frs/?group_id=5428 .*/belenios-(.+)\.tar\.gz

## belenios 1.6+dfsg

=== debian/changelog ===
belenios (1.6+dfsg-1) unstable; urgency=medium

  * New upstream release
    - Fix compilation with OCaml 4.05.0 (Closes: #878980)
  * Update Vcs-* to point to salsa
  * Set pristine-tar filter in debian/gbp.conf
  * Bump Standards-Version to 4.1.4
  * Fix Homepage URL

 -- Stéphane Glondu <glondu@debian.org>  Wed, 13 Jun 2018 15:36:06 +0200

=== debian/watch ===
version=3
opts="dversionmangle=s/\+dfsg//,pgpsigurlmangle=s/$/.asc/" \
https://gforge.inria.fr/frs/?group_id=5428 .*/belenios-(.+)\.tar\.gz

## belenios 1.8+dfsg

=== Makefile ===
--- 
+++ 
@@ -1,14 +1,21 @@
+ALL_TARGETS := all.otarget
+ALL_TARGETS += $(if $(shell sh -c "command -v ocamlopt"),all-native.otarget)
+
 minimal:
+	rm -f _build/BUILD
 	ocamlbuild minimal.otarget
 
 all:
-	ocamlbuild all.otarget
+	rm -f _build/BUILD
+	ocamlbuild $(ALL_TARGETS)
 
-check: all
+check: minimal
 	demo/demo.sh
+	demo/demo-threshold.sh
 
 clean:
-	ocamlbuild -clean
+	-ocamlbuild -clean
+	rm -rf _build
 	rm -f *~
 
 tree: _build/tree.html

=== debian/changelog ===
belenios (1.8+dfsg-1) unstable; urgency=medium

  * New upstream release

 -- Stéphane Glondu <glondu@debian.org>  Mon, 04 Feb 2019 11:43:56 +0100

belenios (1.7.1+dfsg-1) unstable; urgency=medium

  * New upstream release

 -- Stéphane Glondu <glondu@debian.org>  Thu, 10 Jan 2019 11:32:35 +0100

=== debian/control ===
--- 
+++ 
@@ -22,10 +22,10 @@
  texlive-fonts-extra,
  lmodern,
  uuid-runtime
-Standards-Version: 3.9.8
-Homepage: https://www.belenios.org/
-Vcs-Browser: https://anonscm.debian.org/git/pkg-ocaml-maint/packages/belenios.git
-Vcs-Git: https://anonscm.debian.org/git/pkg-ocaml-maint/packages/belenios.git
+Standards-Version: 4.1.4
+Homepage: http://www.belenios.org/
+Vcs-Browser: https://salsa.debian.org/ocaml-team/belenios
+Vcs-Git: https://salsa.debian.org/ocaml-team/belenios.git
 
 Package: belenios-tool
 Architecture: any

=== debian/rules ===
--- 
+++ 
@@ -7,9 +7,13 @@
 .PHONY: override_dh_auto_build
 override_dh_auto_build:
 	$(MAKE) minimal
+ifeq (,$(findstring nodoc,$(DEB_BUILD_OPTIONS)))
 	$(MAKE) doc
+endif
 	_build/belenios-tool --help=groff > debian/belenios-tool.1
 
 .PHONY: override_dh_auto_test
 override_dh_auto_test:
+ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
 	demo/demo.sh
+endif

=== debian/watch ===
version=4
opts="dversionmangle=s/\+dfsg//,repacksuffix=+dfsg,pgpmode=next" https://gforge.inria.fr/frs/?group_id=5428 .*/belenios-(.+)\.tar\.gz
opts="dversionmangle=s/\+dfsg//,repacksuffix=+dfsg,pgpmode=previous" https://gforge.inria.fr/frs/?group_id=5428 .*/belenios-(.+)\.tar\.gz\.asc

## belenios 1.9+dfsg

=== debian/changelog ===
belenios (1.9+dfsg-1) unstable; urgency=medium

  * New upstream release
  * Bump debhelper compat level to 12
  * Bump Standards-Version to 4.4.0

 -- Stéphane Glondu <glondu@debian.org>  Wed, 24 Jul 2019 11:11:21 +0200

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
 Uploaders: Stéphane Glondu <glondu@debian.org>
 Build-Depends:
- debhelper (>= 10),
+ debhelper (>= 12),
  dh-ocaml,
  ocaml-findlib,
  ocamlbuild,
@@ -22,7 +22,7 @@
  texlive-fonts-extra,
  lmodern,
  uuid-runtime
-Standards-Version: 4.1.4
+Standards-Version: 4.4.0
 Homepage: http://www.belenios.org/
 Vcs-Browser: https://salsa.debian.org/ocaml-team/belenios
 Vcs-Git: https://salsa.debian.org/ocaml-team/belenios.git

## belenios 1.10+dfsg

=== Makefile ===
--- 
+++ 
@@ -12,6 +12,7 @@
 check: minimal
 	demo/demo.sh
 	demo/demo-threshold.sh
+	demo/demo-nh.sh
 
 clean:
 	-ocamlbuild -clean

=== requirements.txt ===
# Tools for automated tests
selenium==3.14.0

=== debian/changelog ===
belenios (1.10+dfsg-1) unstable; urgency=medium

  * New upstream release
  * Remove debian/compat and build-depend on debhelper-compat
  * Bump Standards-Version to 4.4.1

 -- Stéphane Glondu <glondu@debian.org>  Tue, 10 Dec 2019 12:57:49 +0100

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
 Uploaders: Stéphane Glondu <glondu@debian.org>
 Build-Depends:
- debhelper (>= 12),
+ debhelper-compat (= 12),
  dh-ocaml,
  ocaml-findlib,
  ocamlbuild,
@@ -20,9 +20,10 @@
  texlive-latex-extra,
  texlive-fonts-recommended,
  texlive-fonts-extra,
+ texlive-science,
  lmodern,
  uuid-runtime
-Standards-Version: 4.4.0
+Standards-Version: 4.4.1
 Homepage: http://www.belenios.org/
 Vcs-Browser: https://salsa.debian.org/ocaml-team/belenios
 Vcs-Git: https://salsa.debian.org/ocaml-team/belenios.git

=== debian/rules ===
--- 
+++ 
@@ -16,4 +16,5 @@
 override_dh_auto_test:
 ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
 	demo/demo.sh
+	demo/demo-threshold.sh
 endif

## belenios 1.11~dfsg

=== Makefile ===
--- 
+++ 
@@ -10,6 +10,7 @@
 	ocamlbuild $(ALL_TARGETS)
 
 check: minimal
+	mkdir -p demo/data
 	demo/demo.sh
 	demo/demo-threshold.sh
 	demo/demo-nh.sh
@@ -37,10 +38,9 @@
 	@if [ `git status --porcelain | grep -v '^?? ' | wc -l ` -eq 0 ]; then \
 	  COMMIT_ID=`git describe --tags`; \
 	  VERSION=`cat VERSION`; \
+	  mkdir -p _build/src/static; \
 	  if [ "$$(printf $$COMMIT_ID | head -c$$(printf $$VERSION | wc -c))" = "$$VERSION" ]; then \
-	    git archive --prefix=belenios-$$COMMIT_ID/ $$COMMIT_ID | gzip -9n > ../belenios-$$COMMIT_ID.tar.gz; \
-	    ln -sf belenios-$$COMMIT_ID.tar.gz ../belenios.tar.gz; \
-	    ls -l ../belenios.tar.gz; \
+	    git archive --prefix=belenios-$$COMMIT_ID/ $$COMMIT_ID | gzip -9n > _build/src/static/belenios.tar.gz; \
 	  else \
 	    echo "VERSION is not up-to-date!"; exit 1; \
 	  fi; \

=== debian/changelog ===
belenios (1.11~dfsg-2) unstable; urgency=medium

  * Include ocamlvars.mk, to avoid FTBFS in dh_dwz
  * Use ~dfsg suffix in debian/watch

 -- Stéphane Glondu <glondu@debian.org>  Tue, 11 Aug 2020 18:01:17 +0200

belenios (1.11~dfsg-1) unstable; urgency=medium

  * New upstream release
  * Bump Standards-Version to 4.5.0
  * Bump debhelper compat level to 13
  * Add Rules-Requires-Root: no

 -- Stéphane Glondu <glondu@debian.org>  Mon, 08 Jun 2020 10:40:20 +0200

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
 Uploaders: Stéphane Glondu <glondu@debian.org>
 Build-Depends:
- debhelper-compat (= 12),
+ debhelper-compat (= 13),
  dh-ocaml,
  ocaml-findlib,
  ocamlbuild,
@@ -23,7 +23,8 @@
  texlive-science,
  lmodern,
  uuid-runtime
-Standards-Version: 4.4.1
+Standards-Version: 4.5.0
+Rules-Requires-Root: no
 Homepage: http://www.belenios.org/
 Vcs-Browser: https://salsa.debian.org/ocaml-team/belenios
 Vcs-Git: https://salsa.debian.org/ocaml-team/belenios.git

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

include /usr/share/ocaml/ocamlvars.mk

%:
	dh $@ --with ocaml

override_dh_auto_build:
	$(MAKE) minimal
ifeq (,$(findstring nodoc,$(DEB_BUILD_OPTIONS)))
	$(MAKE) doc
endif
	_build/belenios-tool --help=groff > debian/belenios-tool.1

override_dh_auto_test:
	mkdir -p demo/data
	demo/demo.sh
	demo/demo-threshold.sh
	demo/demo-nh.sh

=== debian/watch ===
version=4
opts="dversionmangle=s/~dfsg//,repacksuffix=~dfsg,pgpmode=next" https://gforge.inria.fr/frs/?group_id=5428 .*/belenios-(.+)\.tar\.gz
opts="dversionmangle=s/~dfsg//,repacksuffix=~dfsg,pgpmode=previous" https://gforge.inria.fr/frs/?group_id=5428 .*/belenios-(.+)\.tar\.gz\.asc

## belenios 1.14+dfsg

=== Makefile ===
DUNE_DEBUG_ARGS := --build-dir=_build-debug

minimal:
	dune build -p belenios-platform,belenios-platform-native,belenios,belenios-tool

build-debug-server:
	BELENIOS_DEBUG=1 dune build $(DUNE_DEBUG_ARGS)
	rm -rf _run/usr
	dune install $(DUNE_DEBUG_ARGS) --destdir=_run --prefix=/usr 2>/dev/null
	git archive --prefix=belenios-debug/ HEAD | gzip -9n > _run/usr/share/belenios-server/belenios.tar.gz

build-release-server:
	$(MAKE) clean
	BELENIOS_DEBUG= dune build --release
	rm -rf _run/usr
	dune install --destdir=_run --prefix=/usr 2>/dev/null
	git archive --prefix="belenios-$(shell git describe --tags)/" HEAD | gzip -9n > _run/usr/share/belenios-server/belenios.tar.gz

build-debug-tool:
	BELENIOS_DEBUG=1 dune build $(DUNE_DEBUG_ARGS) -p belenios-platform,belenios-platform-native,belenios,belenios-tool
	rm -rf _run/tool-debug
	dune install $(DUNE_DEBUG_ARGS) --destdir=_run/tool-debug --prefix=/ belenios-platform belenios-platform-native belenios belenios-tool 2>/dev/null

check:
	$(MAKE) build-debug-tool
	$(MAKE) -C tests/tool check

clean:
	dune clean
	dune clean $(DUNE_DEBUG_ARGS)
	$(MAKE) -C po clean
	$(MAKE) -C tests/tool clean

.PHONY: doc
doc:
	$(MAKE) doc/specification.pdf

doc/specification.pdf: doc/specification.tex
	cd doc && for u in 1 2 3; do pdflatex specification.tex; done

release:
	@if [ `git status --porcelain | grep -v '^?? ' | wc -l ` -eq 0 ]; then \
	  COMMIT_ID=`git describe --tags`; \
	  VERSION=`cat VERSION`; \
	  mkdir -p _releases; \
	  if [ "$$(printf $$COMMIT_ID | head -c$$(printf $$VERSION | wc -c))" = "$$VERSION" ]; then \
	    git archive --prefix=belenios-$$COMMIT_ID/ $$COMMIT_ID | gzip -9n > _releases/belenios-$$COMMIT_ID.tar.gz; \
	  else \
	    echo "VERSION is not up-to-date!"; exit 1; \
	  fi; \
	else \
	  echo "The tree is not clean!"; exit 1; \
	fi

=== po/admin/Makefile ===
LINGUAS := $(shell cat LINGUAS)

POFILES=$(addsuffix .po,$(LINGUAS))
POTFILE=messages.pot

all: $(POFILES)

clean:
	rm -f *.bak

$(POTFILE): POTFILES
	cd ../.. && ocaml-gettext --action extract --extract-pot po/admin/$@ $(shell cat $^)

%.po: $(POTFILE)
	ocaml-gettext --action merge --merge-pot $^ $@

=== po/voter/Makefile ===
LINGUAS := $(shell cat LINGUAS)

POFILES=$(addsuffix .po,$(LINGUAS))
POTFILE=messages.pot

all: $(POFILES)

clean:
	rm -f *.bak

$(POTFILE): POTFILES
	cd ../.. && ocaml-gettext --action extract --extract-pot po/voter/$@ $(shell cat $^)

%.po: $(POTFILE)
	ocaml-gettext --action merge --merge-pot $^ $@

=== tests/tool/Makefile ===
all:

check:
	mkdir -p data
	./demo.sh
	./demo-threshold.sh
	./demo-nh.sh
	./demo-mj.sh
	./demo-stv.sh

clean:
	rm -rf data

=== debian/changelog ===
belenios (1.14+dfsg-1) unstable; urgency=medium

  * New upstream release

 -- Stéphane Glondu <glondu@debian.org>  Wed, 10 Feb 2021 09:53:45 +0100

belenios (1.13+dfsg-1) unstable; urgency=medium

  * New upstream release

 -- Stéphane Glondu <glondu@debian.org>  Wed, 03 Feb 2021 10:47:52 +0100

=== debian/control ===
--- 
+++ 
@@ -6,8 +6,7 @@
 Build-Depends:
  debhelper-compat (= 13),
  dh-ocaml,
- ocaml-findlib,
- ocamlbuild,
+ ocaml-dune,
  libzarith-ocaml-dev,
  libcalendar-ocaml-dev,
  libuuidm-ocaml-dev,
@@ -21,9 +20,8 @@
  texlive-fonts-recommended,
  texlive-fonts-extra,
  texlive-science,
- lmodern,
- uuid-runtime
-Standards-Version: 4.5.0
+ lmodern
+Standards-Version: 4.5.1
 Rules-Requires-Root: no
 Homepage: http://www.belenios.org/
 Vcs-Browser: https://salsa.debian.org/ocaml-team/belenios

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

include /usr/share/ocaml/ocamlvars.mk

%:
	dh $@ --with ocaml

override_dh_auto_build:
	dune build -p belenios-platform,belenios-platform-native,belenios,belenios-tool
ifeq (,$(findstring nodoc,$(DEB_BUILD_OPTIONS)))
	$(MAKE) doc
endif
	_build/default/src/tool/tool_cmdline.exe --help=groff > debian/belenios-tool.1

override_dh_auto_install:
	dune install --destdir=debian/tmp --prefix=/usr belenios-tool

=== debian/watch ===
version=4
opts="dversionmangle=s/\+dfsg//,repacksuffix=+dfsg,pgpmode=next" https://www.belenios.org/software.html .*/belenios-(.+)\.tar\.gz
opts="dversionmangle=s/\+dfsg//,repacksuffix=+dfsg,pgpmode=previous" https://www.belenios.org/software.html .*/belenios-(.+)\.tar\.gz\.asc

## belenios 1.17+dfsg

=== Makefile ===
--- 
+++ 
@@ -1,25 +1,38 @@
 DUNE_DEBUG_ARGS := --build-dir=_build-debug
 
 minimal:
-	dune build -p belenios-platform,belenios-platform-native,belenios,belenios-tool
+	dune build -p belenios-platform,belenios-platform-native,belenios-lib,belenios-tool
 
 build-debug-server:
 	BELENIOS_DEBUG=1 dune build $(DUNE_DEBUG_ARGS)
+	BELENIOS_DEBUG=1 dune exec $(DUNE_DEBUG_ARGS) -- \
+	  src/checki18next/checki18next.exe --dir frontend/translations \
+	  < src/checki18next/reference.json
 	rm -rf _run/usr
 	dune install $(DUNE_DEBUG_ARGS) --destdir=_run --prefix=/usr 2>/dev/null
+	BELENIOS_DEBUG=1 $(MAKE) DESTDIR=../_run/usr/share/belenios-server/frontend -C frontend
 	git archive --prefix=belenios-debug/ HEAD | gzip -9n > _run/usr/share/belenios-server/belenios.tar.gz
 
 build-release-server:
 	$(MAKE) clean
 	BELENIOS_DEBUG= dune build --release
+	BELENIOS_DEBUG= dune exec $(DUNE_DEBUG_ARGS) -- \
+	  src/checki18next/checki18next.exe --dir frontend/translations \
+	  < src/checki18next/reference.json
 	rm -rf _run/usr
 	dune install --destdir=_run --prefix=/usr 2>/dev/null
+	BELENIOS_DEBUG= $(MAKE) DESTDIR=../_run/usr/share/belenios-server/frontend -C frontend
 	git archive --prefix="belenios-$(shell git describe --tags)/" HEAD | gzip -9n > _run/usr/share/belenios-server/belenios.tar.gz
 
+build-i18next-reference:
+	BELENIOS_DEBUG=1 dune exec $(DUNE_DEBUG_ARGS) -- \
+	  src/checki18next/checki18next.exe --dir frontend/translations --make-reference \
+	  < frontend/translations/en.json > src/checki18next/reference.json
+
 build-debug-tool:
-	BELENIOS_DEBUG=1 dune build $(DUNE_DEBUG_ARGS) -p belenios-platform,belenios-platform-native,belenios,belenios-tool
+	BELENIOS_DEBUG=1 dune build $(DUNE_DEBUG_ARGS) -p belenios-platform,belenios-platform-native,belenios-lib,belenios-tool
 	rm -rf _run/tool-debug
-	dune install $(DUNE_DEBUG_ARGS) --destdir=_run/tool-debug --prefix=/ belenios-platform belenios-platform-native belenios belenios-tool 2>/dev/null
+	dune install $(DUNE_DEBUG_ARGS) --destdir=_run/tool-debug --prefix=/ belenios-platform belenios-platform-native belenios-lib belenios-tool 2>/dev/null
 
 check:
 	$(MAKE) build-debug-tool

=== requirements.txt ===
# Tools for automated tests
selenium==3.141.0
hypothesis==5.6.0

=== frontend/Makefile ===
ifeq "$(BELENIOS_DEBUG)" "1"
    JAVASCRIPT_MODE := development
    JAVASCRIPT_EXTENSION := 
    VOTE_PAGE := vote_development.html
else
    JAVASCRIPT_MODE := production
    JAVASCRIPT_EXTENSION := .min
    VOTE_PAGE := vote.html
endif

ifeq "$(DESTDIR)" ""
	DESTDIR := ./build
endif

REACT_JS_FOLDER := react/umd
REACT_JS_FILENAME := react.$(JAVASCRIPT_MODE)$(JAVASCRIPT_EXTENSION).js
REACT_JS_URL := $(REACT_JS_FOLDER)/$(REACT_JS_FILENAME)
REACT_DOM_JS_FOLDER := react-dom/umd
REACT_DOM_JS_FILENAME := react-dom.$(JAVASCRIPT_MODE)$(JAVASCRIPT_EXTENSION).js
REACT_DOM_JS_URL := $(REACT_DOM_JS_FOLDER)/$(REACT_DOM_JS_FILENAME)
I18NEXT_JS_FOLDER := i18next/dist/umd
I18NEXT_JS_FILENAME := i18next$(JAVASCRIPT_EXTENSION).js
I18NEXT_JS_URL := $(I18NEXT_JS_FOLDER)/$(I18NEXT_JS_FILENAME)
I18NEXT_HTTP_BACKEND_JS_FOLDER := i18next-http-backend
I18NEXT_HTTP_BACKEND_JS_FILENAME := i18nextHttpBackend$(JAVASCRIPT_EXTENSION).js
I18NEXT_HTTP_BACKEND_JS_URL := $(I18NEXT_HTTP_BACKEND_JS_FOLDER)/$(I18NEXT_HTTP_BACKEND_JS_FILENAME)
REACT_I18NEXT_JS_FOLDER := react-i18next/dist/umd
REACT_I18NEXT_JS_FILENAME := react-i18next$(JAVASCRIPT_EXTENSION).js
REACT_I18NEXT_JS_URL := $(REACT_I18NEXT_JS_FOLDER)/$(REACT_I18NEXT_JS_FILENAME)
REACT_BEAUTIFUL_DND_JS_FOLDER := react-beautiful-dnd/dist
REACT_BEAUTIFUL_DND_JS_FILENAME := react-beautiful-dnd$(JAVASCRIPT_EXTENSION).js
REACT_BEAUTIFUL_DND_JS_URL := $(REACT_BEAUTIFUL_DND_JS_FOLDER)/$(REACT_BEAUTIFUL_DND_JS_FILENAME)
INITIAL_EXTERNAL_JS_FOLDER := node_modules
PUBLIC_EXTERNAL_JS_FOLDER := $(DESTDIR)/node_modules
PUBLIC_INTERNAL_JS_FOLDER := $(DESTDIR)
INITIAL_TRANSLATIONS_FOLDER := translations
PUBLIC_TRANSLATIONS_FOLDER := $(DESTDIR)/translations

# The `DESTDIR` variable is used as in [https://www.gnu.org/prep/standards/html_node/DESTDIR.html]. Use value `../_run/usr/share/belenios-server` to install Belenios.
install: $(INITIAL_EXTERNAL_JS_FOLDER)/$(REACT_JS_URL) $(INITIAL_EXTERNAL_JS_FOLDER)/$(REACT_DOM_JS_URL) $(INITIAL_EXTERNAL_JS_FOLDER)/$(I18NEXT_JS_URL) $(INITIAL_EXTERNAL_JS_FOLDER)/$(I18NEXT_HTTP_BACKEND_JS_URL) $(INITIAL_EXTERNAL_JS_FOLDER)/$(REACT_I18NEXT_JS_URL) $(INITIAL_EXTERNAL_JS_FOLDER)/$(REACT_BEAUTIFUL_DND_JS_URL) booth/*.mjs booth/*.js booth/*.css booth/$(VOTE_PAGE) booth/components
	mkdir -p $(PUBLIC_EXTERNAL_JS_FOLDER)/$(REACT_JS_FOLDER)
	cp -r $(INITIAL_EXTERNAL_JS_FOLDER)/$(REACT_JS_URL) $(PUBLIC_EXTERNAL_JS_FOLDER)/$(REACT_JS_URL)
	mkdir -p $(PUBLIC_EXTERNAL_JS_FOLDER)/$(REACT_DOM_JS_FOLDER)
	cp -r $(INITIAL_EXTERNAL_JS_FOLDER)/$(REACT_DOM_JS_URL) $(PUBLIC_EXTERNAL_JS_FOLDER)/$(REACT_DOM_JS_URL)
	mkdir -p $(PUBLIC_EXTERNAL_JS_FOLDER)/$(I18NEXT_JS_FOLDER)
	cp -r $(INITIAL_EXTERNAL_JS_FOLDER)/$(I18NEXT_JS_URL) $(PUBLIC_EXTERNAL_JS_FOLDER)/$(I18NEXT_JS_URL)
	mkdir -p $(PUBLIC_EXTERNAL_JS_FOLDER)/$(I18NEXT_HTTP_BACKEND_JS_FOLDER)
	cp -r $(INITIAL_EXTERNAL_JS_FOLDER)/$(I18NEXT_HTTP_BACKEND_JS_URL) $(PUBLIC_EXTERNAL_JS_FOLDER)/$(I18NEXT_HTTP_BACKEND_JS_URL)
	mkdir -p $(PUBLIC_EXTERNAL_JS_FOLDER)/$(REACT_I18NEXT_JS_FOLDER)
	cp -r $(INITIAL_EXTERNAL_JS_FOLDER)/$(REACT_I18NEXT_JS_URL) $(PUBLIC_EXTERNAL_JS_FOLDER)/$(REACT_I18NEXT_JS_URL)
	mkdir -p $(PUBLIC_EXTERNAL_JS_FOLDER)/$(REACT_BEAUTIFUL_DND_JS_FOLDER)
	cp -r $(INITIAL_EXTERNAL_JS_FOLDER)/$(REACT_BEAUTIFUL_DND_JS_URL) $(PUBLIC_EXTERNAL_JS_FOLDER)/$(REACT_BEAUTIFUL_DND_JS_URL)
	mkdir -p $(PUBLIC_INTERNAL_JS_FOLDER)/booth
	cp -r booth/*.mjs booth/*.js booth/*.css booth/components $(PUBLIC_INTERNAL_JS_FOLDER)/booth/
	cp -r booth/$(VOTE_PAGE) $(PUBLIC_INTERNAL_JS_FOLDER)/booth/vote.html
	mkdir -p $(PUBLIC_TRANSLATIONS_FOLDER)
	cp -r $(INITIAL_TRANSLATIONS_FOLDER)/* $(PUBLIC_TRANSLATIONS_FOLDER)/

$(INITIAL_EXTERNAL_JS_FOLDER)/$(REACT_JS_URL) $(INITIAL_EXTERNAL_JS_FOLDER)/$(REACT_DOM_JS_URL) $(INITIAL_EXTERNAL_JS_FOLDER)/$(I18NEXT_JS_URL) $(INITIAL_EXTERNAL_JS_FOLDER)/$(I18NEXT_HTTP_BACKEND_JS_URL) $(INITIAL_EXTERNAL_JS_FOLDER)/$(REACT_I18NEXT_JS_URL) $(INITIAL_EXTERNAL_JS_FOLDER)/$(REACT_BEAUTIFUL_DND_JS_URL): package-lock.json

package-lock.json: package.json
	npm install

.PHONY: install

=== debian/changelog ===
belenios (1.17+dfsg-1) unstable; urgency=medium

  * New upstream release
  * Bump Standards-Version to 4.6.0 (no changes)

 -- Stéphane Glondu <glondu@debian.org>  Wed, 08 Sep 2021 10:27:06 +0200

=== debian/control ===
--- 
+++ 
@@ -21,7 +21,7 @@
  texlive-fonts-extra,
  texlive-science,
  lmodern
-Standards-Version: 4.5.1
+Standards-Version: 4.6.0
 Rules-Requires-Root: no
 Homepage: http://www.belenios.org/
 Vcs-Browser: https://salsa.debian.org/ocaml-team/belenios

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

include /usr/share/ocaml/ocamlvars.mk

%:
	dh $@ --with ocaml

override_dh_auto_build:
	dune build -p belenios-platform,belenios-platform-native,belenios-lib,belenios-tool
ifeq (,$(findstring nodoc,$(DEB_BUILD_OPTIONS)))
	$(MAKE) doc
endif
	_build/default/src/tool/cmdline/tool_cmdline.exe --help=groff > debian/belenios-tool.1

override_dh_auto_install:
	dune install --destdir=debian/tmp --prefix=/usr belenios-tool

## belenios 1.19+dfsg

=== debian/changelog ===
belenios (1.19+dfsg-1) unstable; urgency=medium

  * New upstream release

 -- Stéphane Glondu <glondu@debian.org>  Thu, 11 Aug 2022 10:41:19 +0200

=== debian/control ===
--- 
+++ 
@@ -13,7 +13,7 @@
  libcryptokit-ocaml-dev,
  libatdgen-ocaml-dev,
  libyojson-ocaml-dev,
- libcmdliner-ocaml-dev,
+ libcmdliner-ocaml-dev (>= 1.1),
  ocaml-nox,
  markdown,
  texlive-latex-extra,

## belenios 1.20+dfsg

=== debian/changelog ===
belenios (1.20+dfsg-1) unstable; urgency=medium

  * New upstream release
  * Bump Standards-Version to 4.6.1 (no changes)

 -- Stéphane Glondu <glondu@debian.org>  Mon, 24 Oct 2022 10:37:30 +0200

## belenios 2.0+dfsg

=== Makefile ===
--- 
+++ 
@@ -1,4 +1,7 @@
+BELENIOS_BUILD := $(shell ./src/platform/version/get_build.sh)
 DUNE_DEBUG_ARGS := --build-dir=_build-debug
+
+export BELENIOS_BUILD
 
 minimal:
 	dune build -p belenios-platform,belenios-platform-native,belenios-lib,belenios-tool
@@ -6,8 +9,8 @@
 build-debug-server:
 	BELENIOS_DEBUG=1 dune build $(DUNE_DEBUG_ARGS)
 	BELENIOS_DEBUG=1 dune exec $(DUNE_DEBUG_ARGS) -- \
-	  src/checki18next/checki18next.exe --dir frontend/translations \
-	  < src/checki18next/reference.json
+	  src/scripts/checki18next/checki18next.exe --dir frontend/translations \
+	  < src/scripts/checki18next/reference.json
 	rm -rf _run/usr
 	dune install $(DUNE_DEBUG_ARGS) --destdir=_run --prefix=/usr 2>/dev/null
 	BELENIOS_DEBUG=1 $(MAKE) DESTDIR=../_run/usr/share/belenios-server/frontend -C frontend
@@ -17,8 +20,8 @@
 	$(MAKE) clean
 	BELENIOS_DEBUG= dune build --release
 	BELENIOS_DEBUG= dune exec $(DUNE_DEBUG_ARGS) -- \
-	  src/checki18next/checki18next.exe --dir frontend/translations \
-	  < src/checki18next/reference.json
+	  src/scripts/checki18next/checki18next.exe --dir frontend/translations \
+	  < src/scripts/checki18next/reference.json
 	rm -rf _run/usr
 	dune install --destdir=_run --prefix=/usr 2>/dev/null
 	BELENIOS_DEBUG= $(MAKE) DESTDIR=../_run/usr/share/belenios-server/frontend -C frontend
@@ -26,8 +29,8 @@
 
 build-i18next-reference:
 	BELENIOS_DEBUG=1 dune exec $(DUNE_DEBUG_ARGS) -- \
-	  src/checki18next/checki18next.exe --dir frontend/translations --make-reference \
-	  < frontend/translations/en.json > src/checki18next/reference.json
+	  src/scripts/checki18next/checki18next.exe --dir frontend/translations --make-reference \
+	  < frontend/translations/en.json > src/scripts/checki18next/reference.json
 
 build-debug-tool:
 	BELENIOS_DEBUG=1 dune build $(DUNE_DEBUG_ARGS) -p belenios-platform,belenios-platform-native,belenios-lib,belenios-tool
@@ -43,6 +46,7 @@
 	dune clean $(DUNE_DEBUG_ARGS)
 	$(MAKE) -C po clean
 	$(MAKE) -C tests/tool clean
+	rm -f geckodriver.log
 
 .PHONY: doc
 doc:

=== frontend/Makefile ===
--- 
+++ 
@@ -1,6 +1,6 @@
 ifeq "$(BELENIOS_DEBUG)" "1"
     JAVASCRIPT_MODE := development
-    JAVASCRIPT_EXTENSION := 
+    JAVASCRIPT_EXTENSION :=
     VOTE_PAGE := vote_development.html
 else
     JAVASCRIPT_MODE := production

=== debian/changelog ===
belenios (2.0+dfsg-1) unstable; urgency=medium

  * New upstream release

 -- Stéphane Glondu <glondu@debian.org>  Mon, 02 Jan 2023 10:34:38 +0100

=== debian/control ===
--- 
+++ 
@@ -11,9 +11,11 @@
  libcalendar-ocaml-dev,
  libuuidm-ocaml-dev,
  libcryptokit-ocaml-dev,
- libatdgen-ocaml-dev,
+ libatdgen-ocaml-dev (>= 2.10.0),
  libyojson-ocaml-dev,
  libcmdliner-ocaml-dev (>= 1.1),
+ libhex-ocaml-dev,
+ libbase64-ocaml-dev,
  ocaml-nox,
  markdown,
  texlive-latex-extra,
@@ -21,7 +23,7 @@
  texlive-fonts-extra,
  texlive-science,
  lmodern
-Standards-Version: 4.6.0
+Standards-Version: 4.6.1
 Rules-Requires-Root: no
 Homepage: http://www.belenios.org/
 Vcs-Browser: https://salsa.debian.org/ocaml-team/belenios

## belenios 2.2+git10

=== Makefile ===
BELENIOS_BUILD := $(shell ./src/platform/version/get_build.sh)
DUNE_DEBUG_ARGS := --build-dir=_build-debug
BELENIOS_SRC := _run/usr/share/belenios-server/belenios.tar.gz

export BELENIOS_BUILD

minimal:
	dune build -p belenios-platform,belenios-platform-native,belenios-lib,belenios-tool

MANIFEST:
	git ls-files > $@

$(BELENIOS_SRC): MANIFEST
	tar -czf $@ --transform='s,^,belenios/,' --verbatim-files-from --files-from=$<

build-debug-server:
	BELENIOS_DEBUG=1 dune build $(DUNE_DEBUG_ARGS)
	BELENIOS_DEBUG=1 dune exec $(DUNE_DEBUG_ARGS) -- \
	  src/scripts/checki18next/checki18next.exe --dir frontend/translations \
	  < src/scripts/checki18next/reference.json
	rm -rf _run/usr
	dune install $(DUNE_DEBUG_ARGS) --display=quiet --destdir=_run --prefix=/usr
	BELENIOS_DEBUG=1 $(MAKE) DESTDIR=../_run/usr/share/belenios-server -C frontend
	rm -f $(BELENIOS_SRC) && $(MAKE) $(BELENIOS_SRC)

build-release-server:
	$(MAKE) clean
	BELENIOS_DEBUG= dune build --release
	BELENIOS_DEBUG= dune exec $(DUNE_DEBUG_ARGS) -- \
	  src/scripts/checki18next/checki18next.exe --dir frontend/translations \
	  < src/scripts/checki18next/reference.json
	rm -rf _run/usr
	dune install --display=quiet --destdir=_run --prefix=/usr
	BELENIOS_DEBUG= $(MAKE) DESTDIR=../_run/usr/share/belenios-server -C frontend
	rm -f $(BELENIOS_SRC) && $(MAKE) $(BELENIOS_SRC)

build-i18next-reference:
	BELENIOS_DEBUG=1 dune exec $(DUNE_DEBUG_ARGS) -- \
	  src/scripts/checki18next/checki18next.exe --dir frontend/translations --make-reference \
	  < frontend/translations/en.json > src/scripts/checki18next/reference.json

build-debug-tool:
	BELENIOS_DEBUG=1 dune build $(DUNE_DEBUG_ARGS) -p belenios-platform,belenios-platform-native,belenios-lib,belenios-tool
	rm -rf _run/tool-debug
	dune install $(DUNE_DEBUG_ARGS) --display=quiet --destdir=_run/tool-debug --prefix=/ belenios-platform belenios-platform-native belenios-lib belenios-tool

check:
	$(MAKE) build-debug-tool
	$(MAKE) -C tests/tool check

clean:
	dune clean
	dune clean $(DUNE_DEBUG_ARGS)
	$(MAKE) -C po clean
	$(MAKE) -C tests/tool clean
	$(MAKE) -C frontend clean
	rm -rf geckodriver.log venv .hypothesis _tests
	find tests -name __pycache__ -print0 | xargs -0 rm -rf

.PHONY: doc
doc:
	$(MAKE) doc/specification.pdf

doc/specification.pdf: doc/specification.tex doc/spec_version.tex
	cd doc && for u in 1 2 3; do pdflatex specification.tex; done

release:
	@if [ `git status --porcelain | grep -v '^?? ' | wc -l ` -eq 0 ]; then \
	  COMMIT_ID=`git describe --tags`; \
	  VERSION=`cat VERSION`; \
	  mkdir -p _releases; \
	  if [ "$$(printf $$COMMIT_ID | head -c$$(printf $$VERSION | wc -c))" = "$$VERSION" ]; then \
	    git archive --prefix=belenios-$$COMMIT_ID/ $$COMMIT_ID | gzip -9n > _releases/belenios-$$COMMIT_ID.tar.gz; \
	  else \
	    echo "VERSION is not up-to-date!"; exit 1; \
	  fi; \
	else \
	  echo "The tree is not clean!"; exit 1; \
	fi

=== requirements.txt ===
# Tools for automated tests
selenium==3.141.0
hypothesis==5.6.0
urllib3==1.26.15

=== frontend/Makefile ===
CSS_DEPS := $(wildcard ../ext/css/*.css ../src/web/static/*.css booth/*.css booth/components/*.css)

ifeq "$(BELENIOS_DEBUG)" "1"
    BUNDLE := bundle.development.js
    VOTE_PAGE := vote.html
else
    BUNDLE := bundle.production.js
    VOTE_PAGE := vote.html
endif

ifeq "$(DESTDIR)" ""
	DESTDIR := ./build
endif

PUBLIC_INTERNAL_JS_FOLDER := $(DESTDIR)/frontend
INITIAL_TRANSLATIONS_FOLDER := translations
PUBLIC_TRANSLATIONS_FOLDER := $(DESTDIR)/frontend/translations

# The `DESTDIR` variable is used as in [https://www.gnu.org/prep/standards/html_node/DESTDIR.html]. Use value `../_run/usr/share/belenios-server` to install Belenios.
install: site.bundle.css booth/bundle.js booth/app.bundle.css booth/$(VOTE_PAGE)
	mkdir -p $(PUBLIC_INTERNAL_JS_FOLDER)/booth
	cp *.bundle.css $(DESTDIR)
	cp -r booth/bundle.js booth/app.bundle.css $(PUBLIC_INTERNAL_JS_FOLDER)/booth/
	cp -r booth/$(VOTE_PAGE) $(PUBLIC_INTERNAL_JS_FOLDER)/booth/vote.html
	mkdir -p $(PUBLIC_TRANSLATIONS_FOLDER)
	cp -r $(INITIAL_TRANSLATIONS_FOLDER)/* $(PUBLIC_TRANSLATIONS_FOLDER)/

format:
	npx prettier ./booth --write

booth/dist/bundle.production.js: package-lock.json booth/*.js booth/components/*.js
	( cd booth && npx webpack --config webpack.config.js --mode production ) && mv booth/dist/bundle.js $@

booth/dist/bundle.development.js: package-lock.json booth/*.js booth/components/*.js
	( cd booth && npx webpack --config webpack.config.js --mode development ) && mv booth/dist/bundle.js $@

booth/bundle.js: booth/dist/$(BUNDLE)
	cp $< $@

site.bundle.css: package-lock.json $(CSS_DEPS)
	NODE_PATH=$(CURDIR)/node_modules nodejs ./bundle-css.js ../src/web/static/responsive_site.css > $@

booth/app.bundle.css: package-lock.json $(CSS_DEPS)
	NODE_PATH=$(CURDIR)/node_modules nodejs ./bundle-css.js booth/app.css > $@

package-lock.json: package.json
	npm install

.PHONY: install clean

clean:
	rm -rf package-lock.json node_modules booth/dist booth/bundle.js *.bundle.css booth/*.bundle.css

=== po/Makefile ===
all:
	$(MAKE) -C voter all
	$(MAKE) -C admin all

clean:
	$(MAKE) -C voter clean
	$(MAKE) -C admin clean

=== po/voter/Makefile ===
--- 
+++ 
@@ -3,7 +3,10 @@
 POFILES=$(addsuffix .po,$(LINGUAS))
 POTFILE=messages.pot
 
-all: $(POFILES)
+all: dune $(POFILES)
+
+dune: LINGUAS
+	../gen-dune.sh voter < $^ > $@
 
 clean:
 	rm -f *.bak

=== tests/tool/Makefile ===
--- 
+++ 
@@ -7,6 +7,7 @@
 	./demo-nh.sh
 	./demo-mj.sh
 	./demo-stv.sh
+	./demo-n-voters.sh
 
 clean:
 	rm -rf data

## belenios 2.2+git10-gbb6b7ea8+dfsg

=== debian/changelog ===
belenios (2.2+git10-gbb6b7ea8+dfsg-1) unstable; urgency=medium

  * New upstream release
  * Depend on ocaml instead of transitional ocaml-nox
  * Update debian/watch
  * Bump Standards-Version to 4.6.2

 -- Stéphane Glondu <glondu@debian.org>  Wed, 06 Sep 2023 13:31:33 +0200

=== debian/control ===
--- 
+++ 
@@ -16,14 +16,16 @@
  libcmdliner-ocaml-dev (>= 1.1),
  libhex-ocaml-dev,
  libbase64-ocaml-dev,
- ocaml-nox,
+ libsodium-dev,
+ jq <!nocheck>,
+ ocaml,
  markdown,
  texlive-latex-extra,
  texlive-fonts-recommended,
  texlive-fonts-extra,
  texlive-science,
  lmodern
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Rules-Requires-Root: no
 Homepage: http://www.belenios.org/
 Vcs-Browser: https://salsa.debian.org/ocaml-team/belenios

=== debian/rules ===
--- 
+++ 
@@ -11,7 +11,7 @@
 ifeq (,$(findstring nodoc,$(DEB_BUILD_OPTIONS)))
 	$(MAKE) doc
 endif
-	_build/default/src/tool/cmdline/tool_cmdline.exe --help=groff > debian/belenios-tool.1
+	_build/install/default/bin/belenios-tool --help=groff > debian/belenios-tool.1
 
 override_dh_auto_install:
 	dune install --destdir=debian/tmp --prefix=/usr belenios-tool

## belenios 2.5.1+dfsg

=== Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
 BELENIOS_BUILD := $(shell ./src/platform/version/get_build.sh)
-DUNE_DEBUG_ARGS := --build-dir=_build-debug
+DUNE_DEBUG_ARGS :=
 BELENIOS_SRC := _run/usr/share/belenios-server/belenios.tar.gz
 
 export BELENIOS_BUILD

=== requirements.txt ===
# Tools for automated tests
selenium==4.14.0
hypothesis==5.6.0
urllib3==1.26.18

=== debian/changelog ===
belenios (2.5.1+dfsg-1) unstable; urgency=medium

  * New upstream release
  * Fix cleaning (Closes: #1043725)
  * Drop dependency on markdown (Closes: #1073091)
  * Bump Standards-Version to 4.7.0

 -- Stéphane Glondu <glondu@debian.org>  Tue, 02 Jul 2024 05:19:19 +0200

=== debian/control ===
--- 
+++ 
@@ -19,13 +19,12 @@
  libsodium-dev,
  jq <!nocheck>,
  ocaml,
- markdown,
- texlive-latex-extra,
- texlive-fonts-recommended,
- texlive-fonts-extra,
- texlive-science,
- lmodern
-Standards-Version: 4.6.2
+ texlive-latex-extra <!nodoc>,
+ texlive-fonts-recommended <!nodoc>,
+ texlive-fonts-extra <!nodoc>,
+ texlive-science <!nodoc>,
+ lmodern <!nodoc>
+Standards-Version: 4.7.0
 Rules-Requires-Root: no
 Homepage: http://www.belenios.org/
 Vcs-Browser: https://salsa.debian.org/ocaml-team/belenios

## belenios 3.0%2Bdfsg

=== tests/tool/Makefile ===
--- 
+++ 
@@ -7,7 +7,9 @@
 	./demo-nh.sh
 	./demo-mj.sh
 	./demo-stv.sh
+	./demo-l.sh
 	./demo-n-voters.sh
+	./demo-complex.sh
 
 clean:
 	rm -rf data

## belenios 3.0+dfsg

=== Makefile ===
--- 
+++ 
@@ -1,19 +1,18 @@
 BELENIOS_BUILD := $(shell ./src/platform/version/get_build.sh)
 DUNE_DEBUG_ARGS :=
 BELENIOS_SRC := _run/usr/share/belenios-server/belenios.tar.gz
+DOCUMENTATION := doc/specification.pdf doc/instructions-en.html doc/instructions-fr.html
 
 export BELENIOS_BUILD
 
 minimal:
 	dune build -p belenios-platform,belenios-platform-native,belenios-lib,belenios-tool
 
-MANIFEST:
-	git ls-files > $@
-
-$(BELENIOS_SRC): MANIFEST
-	tar -czf $@ --transform='s,^,belenios/,' --verbatim-files-from --files-from=$<
+$(BELENIOS_SRC):
+	contrib/make-tarball.sh $@
 
 build-debug-server:
+	@echo "Building Belenios server $(BELENIOS_BUILD) in debug mode..."
 	BELENIOS_DEBUG=1 dune build $(DUNE_DEBUG_ARGS)
 	BELENIOS_DEBUG=1 dune exec $(DUNE_DEBUG_ARGS) -- \
 	  src/scripts/checki18next/checki18next.exe --dir frontend/translations \
@@ -25,6 +24,7 @@
 
 build-release-server:
 	$(MAKE) clean
+	@echo "Building Belenios server $(BELENIOS_BUILD) in release mode..."
 	BELENIOS_DEBUG= dune build --release
 	BELENIOS_DEBUG= dune exec $(DUNE_DEBUG_ARGS) -- \
 	  src/scripts/checki18next/checki18next.exe --dir frontend/translations \
@@ -59,18 +59,27 @@
 
 .PHONY: doc
 doc:
-	$(MAKE) doc/specification.pdf
+	$(MAKE) $(DOCUMENTATION)
+
+install-doc: doc
+ifeq ($(DESTDIR),)
+	$(error Please define DESTDIR)
+else
+	cp $(DOCUMENTATION) $(DESTDIR)
+endif
 
 doc/specification.pdf: doc/specification.tex doc/spec_version.tex
-	cd doc && for u in 1 2 3; do pdflatex specification.tex; done
+	cd doc && rubber --pdf specification.tex
+
+%.html: %.md
+	pandoc -o $@ $<
 
 release:
 	@if [ `git status --porcelain | grep -v '^?? ' | wc -l ` -eq 0 ]; then \
-	  COMMIT_ID=`git describe --tags`; \
 	  VERSION=`cat VERSION`; \
 	  mkdir -p _releases; \
-	  if [ "$$(printf $$COMMIT_ID | head -c$$(printf $$VERSION | wc -c))" = "$$VERSION" ]; then \
-	    git archive --prefix=belenios-$$COMMIT_ID/ $$COMMIT_ID | gzip -9n > _releases/belenios-$$COMMIT_ID.tar.gz; \
+	  if [ "$$(printf $(BELENIOS_BUILD) | head -c$$(printf $$VERSION | wc -c))" = "$$VERSION" ]; then \
+	    git archive --prefix=belenios-$(BELENIOS_BUILD)/ $(BELENIOS_BUILD) | gzip -9n > _releases/belenios-$(BELENIOS_BUILD).tar.gz; \
 	  else \
 	    echo "VERSION is not up-to-date!"; exit 1; \
 	  fi; \

=== frontend/Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-CSS_DEPS := $(wildcard ../ext/css/*.css ../src/web/static/*.css booth/*.css booth/components/*.css)
+CSS_DEPS := $(wildcard ../vendor/css/*.css ../src/web/static/*.css booth/*.css booth/components/*.css)
 
 ifeq "$(BELENIOS_DEBUG)" "1"
     BUNDLE := bundle.development.js
@@ -12,16 +12,16 @@
 	DESTDIR := ./build
 endif
 
-PUBLIC_INTERNAL_JS_FOLDER := $(DESTDIR)/frontend
+PUBLIC_INTERNAL_JS_FOLDER := $(DESTDIR)/static/frontend
 INITIAL_TRANSLATIONS_FOLDER := translations
-PUBLIC_TRANSLATIONS_FOLDER := $(DESTDIR)/frontend/translations
+PUBLIC_TRANSLATIONS_FOLDER := $(DESTDIR)/static/frontend/translations
 
-# The `DESTDIR` variable is used as in [https://www.gnu.org/prep/standards/html_node/DESTDIR.html]. Use value `../_run/usr/share/belenios-server` to install Belenios.
+# The `DESTDIR` variable is used as in [https://www.gnu.org/prep/standards/html_node/DESTDIR.html]. Use value `../_run/usr/share/belenios-server/static` to install Belenios.
 install: site.bundle.css booth/bundle.js booth/app.bundle.css booth/$(VOTE_PAGE)
 	mkdir -p $(PUBLIC_INTERNAL_JS_FOLDER)/booth
-	cp *.bundle.css $(DESTDIR)
+	cp *.bundle.css $(DESTDIR)/static
 	cp -r booth/bundle.js booth/app.bundle.css $(PUBLIC_INTERNAL_JS_FOLDER)/booth/
-	cp -r booth/$(VOTE_PAGE) $(PUBLIC_INTERNAL_JS_FOLDER)/booth/vote.html
+	cp -r booth/$(VOTE_PAGE) $(DESTDIR)/apps
 	mkdir -p $(PUBLIC_TRANSLATIONS_FOLDER)
 	cp -r $(INITIAL_TRANSLATIONS_FOLDER)/* $(PUBLIC_TRANSLATIONS_FOLDER)/

=== po/admin/Makefile ===
--- 
+++ 
@@ -3,7 +3,10 @@
 POFILES=$(addsuffix .po,$(LINGUAS))
 POTFILE=messages.pot
 
-all: $(POFILES)
+all: dune $(POFILES)
+
+dune: LINGUAS
+	../gen-dune.sh admin < $^ > $@
 
 clean:
 	rm -f *.bak

=== debian/changelog ===
belenios (3.0+dfsg-2) unstable; urgency=medium

  * Fix build with atdgen 2.16 (Closes: #1096244)

 -- Stéphane Glondu <glondu@debian.org>  Thu, 20 Feb 2025 10:49:59 +0100

belenios (3.0+dfsg-1) unstable; urgency=medium

  * New upstream release

 -- Stéphane Glondu <glondu@debian.org>  Tue, 26 Nov 2024 13:39:19 +0100

=== debian/control ===
--- 
+++ 
@@ -16,9 +16,12 @@
  libcmdliner-ocaml-dev (>= 1.1),
  libhex-ocaml-dev,
  libbase64-ocaml-dev,
+ libcohttp-lwt-unix-ocaml-dev,
  libsodium-dev,
  jq <!nocheck>,
  ocaml,
+ pandoc <!nodoc>,
+ rubber <!nodoc>,
  texlive-latex-extra <!nodoc>,
  texlive-fonts-recommended <!nodoc>,
  texlive-fonts-extra <!nodoc>,

=== debian/rules ===
--- 
+++ 
@@ -5,6 +5,9 @@
 
 %:
 	dh $@ --with ocaml
+
+execute_after_dh_auto_clean:
+	rm -rf _run
 
 override_dh_auto_build:
 	dune build -p belenios-platform,belenios-platform-native,belenios-lib,belenios-tool

=== debian/watch ===
version=4
opts="dversionmangle=s/\+dfsg//,repacksuffix=+dfsg,pgpmode=next" https://www.belenios.org/software.html .*/belenios-(.+)\.tar\.gz
opts="dversionmangle=s/\+dfsg//,repacksuffix=+dfsg,pgpmode=previous" https://www.belenios.org/software.html .*/belenios-(.+)\.tar\.gz\.(?:asc|sig)
